(document:surround "/std/frame")

margin 100
spacing 10

(define *common-data* (make-cell '()))
(define *df-data* (make-cell '()))
(define *cpu-data* (make-cell '()))

(woo-catch/message (thunk
  (cell-set! *common-data* (woo-read-first "sysinfo"))
  (cell-set! *df-data* (woo-list "sysinfo/df"))
  (cell-set! *cpu-data* (woo-list "sysinfo/cpu")) ))


(define (get-ltext n)
  (bold (woo-get-option (cell-ref *common-data*) n "")))

(define (mktable data . fields)
    (fold
      (lambda (data lst)
        (append lst
          (map
            (lambda (x) (label align "left" text (bold (woo-get-option data x ""))))
            fields)))
      '() (cell-ref data) ) )

(define (mktable-h . fields)
  (map
    (lambda (x) (label align "left" text x))
    fields))


(gridbox columns "10;90"
  (label text (_ "Kernel version:"))
  (label text (get-ltext 'kernel)) )

(groupbox title (_ "Processors")
  (apply gridbox columns "0;60;20;20"
    (mktable-h "N" (_ "Model name") (_ "Frequency") (_ "Cache"))
    (separator colspan 4)
    (mktable *cpu-data* 'num 'name 'freq 'cache) ))

(groupbox title (_ "Memory usage")
  (gridbox columns "40;20;20;20"
    (spacer)
    (mktable-h (_ "Total") (_ "Free") (_ "Used"))
    (separator colspan 4)

    (label text (_ "Memory:"))
    (label text (get-ltext 'memory_total))
    (label text (get-ltext 'memory_free))
    (label text (bold (string-append (get-ltext 'memory_used) " (" (get-ltext 'memory_perc) "%)" )))

    (label text (_ "Swap space:"))
    (label text (get-ltext 'swap_total))
    (label text (get-ltext 'swap_free))
    (label text (bold (string-append (get-ltext 'swap_used) " (" (get-ltext 'swap_perc) "%)" ))) ))

(groupbox title (_ "Disk usage")
  (apply gridbox columns "40;20;20;20"
    (mktable-h (_ "Mount point") (_ "Total") (_ "Free") (_ "Used"))
    (separator colspan 4)
    (mktable *df-data* 'name 'disk_total 'disk_free 'disk_used) ))


